// Diamond Drehgestell 0 Schmalspur


//Variablen und Konstanten Deklaration
$fn=100; // "Rundheit" der gebogenen Teile. Zum Ausprobieren Werte um 30-50 (schnell, mäßige Qualität), zum finalen Rendern Werte um 100-300 (langsam, gute Qualität)

$render = 3; // 1 = Es wird nur das Seitenteil gerendert. 2 = Es wird nur das Mittelteil gerendert. 3 = Es wird ein ganzes Drehgestell am Stück gerendert. Besser nicht am Stück drucken.

$width=0; // Anpassung der Achslänge. 0 entspricht 24,75 mm Abweichungen können positiv (also z.b 1.25 für 26mm lange Achsen) oder auch negativ (also z.b -0.35 für 24,4mm lange Achsen) sein

$bearing=0; // Bestimmt, ob Aussparungen für Messing Lagerbuchsen vorgesehen werden sollen. 0 = nein, 1 = ja, 2 = 2mm Messingrohr als Lager 3 = 2.5mm Messingrohr als Lager

$h=0; // Erhöhung des Drehkranz um Fahrzeughöhen auszugleichen. Mögliche Werte von -0.3 bis 2.0

// Ab hier nur für interne Berechnungen, bitte nichts ändern!!!
$cor=$width/2;
 
//Konstruktion
//

// Federmodul
module spring(){
import("Feder.stl", convexity=3);
}
//

// Gewindemodul
module bolt(){
scale([0.15,0.15,0.15])import("Gewinde.stl", convexity=3);
}
//

//Seitenrahmen- Modul
module seite(){
    
//Basisträger
cube([2.2,34.5,1],true);

//Zylinder kurz
translate([0,-16,-0.2])cylinder(h=6,d=1.75);

translate([0,-16,5.9])cylinder(h=1,d=1.7, $fn=6);

translate([0,-16,-0.9])cylinder(h=1,d=1.7, $fn=6);
translate([0,-16,-2.1])bolt();

translate([0,-11,-0.2])cylinder(h=6,d=1.75);

translate([0,-11,-2.1])bolt();
    
translate([0,-11,5.9])
    cylinder(h=1,d=1.7, $fn=6);
   
translate([0,-11,-0.9])
    cylinder(h=1,d=1.7, $fn=6);
    
translate([0,16,-0.2])cylinder(h=6,d=1.75);
translate([0,16,5.9])cylinder(h=1,d=1.7, $fn=6);
translate([0,16,-0.9])cylinder(h=1,d=1.7, $fn=6);
translate([0,16,-2.1])bolt();

translate([0,11,-0.2])cylinder(h=6,d=1.75);
translate([0,11,5.9])cylinder(h=1,d=1.7, $fn=6);
translate([0,11,-0.9])cylinder(h=1,d=1.7, $fn=6);
translate([0,11,-2.1])bolt();

//Trägerplatte mitte
difference(){
translate([0,0,6])cube([2.2,34.5,1],true);
translate([0,0,6])cube([2.4,19.8,1.75],true);
}

// Zylinder lang
translate([0,3.6,-0.2])cylinder(h=9,d=1.75);
translate([0,-3.6,-0.2])cylinder(h=9,d=1.75);

//Trägerplatte oben
translate([0,0,9])cube([2.2,9.0,1],true);

// Diagonalstreben
translate([0,-7.1,3.02])rotate([-45,0,0])cube([2.2,8.8,1],true);

translate([0,7.1,3.02])rotate([45,0,0])cube([2.2,8.8,1],true);

translate([0,-7.09,7.54])rotate([28.5,0,0])cube([2.2,6.4,1],true);

translate([0,7.09,7.54])rotate([-28.5,0,0])cube([2.2,6.4,1],true);

// Achslager
translate([1.9,13.5,4])difference(){union(){
cube([6,3.6,3.2],true);
translate([-3,0,-1.8])rotate([0,90,0])cylinder(h=6, d=3.6);
 translate([-2.4,0,-1])cube([1.2,3.8,5.95],true);
 }
 if($bearing==0)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=2.6, d1=2.6, d2=0);
 
 if($bearing==1)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=3.2, d1=3.2, d2=0);

 if($bearing==2)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=3.5, d=2.2);
 
  if($bearing==3)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=3.5, d=2.7);

 //Schmierklappe Abschrägung
 rotate([0,-12.5,0])translate([1.2,-5,-5])cube([10,10,10]);
 }
 
 //Schmierklappe
 union(){rotate([0,77.0,0])translate([-2.15,13.5,4])minkowski(){cube([4.9,3.5,0.4],true);
    cylinder(h=0.1, d=0.5);
  }
 
rotate([0,77.0,0])translate([-2.51,13.7,4.3])minkowski(){cube([2.0,0.8,0.4],true);
    cylinder(h=0.1, d=0.5);
  }  
 translate([4.0,14.3,2.75])rotate([90,0,0])cylinder(h=1.2, d=0.4);
union(){
translate([3.23,15.5,3.0])rotate([0,77,0])cylinder(h=0.5, d=1.4);

translate([3.56,15.6,3.0])rotate([0,77,0])cylinder(h=0.5, d=0.8, $fn=6);

translate([2.2,15.6,2.61])rotate([0,77,0])scale([0.6,0.6,1])bolt();
}

translate([0,-3.95,0])union(){
translate([3.23,15.5,3.0])rotate([0,77,0])cylinder(h=0.5, d=1.4);

translate([3.56,15.6,3.0])rotate([0,77,0])cylinder(h=0.5, d=0.8, $fn=6);
translate([2.2,15.6,2.61])rotate([0,77,0])scale([0.6,0.6,1])bolt();
}

}
//Achslagerbohrungen  
translate([1.9,-13.5,4])difference(){union(){
cube([6,3.6,3.2],true);
translate([-3,0,-1.8])rotate([0,90,0])cylinder(h=6, d=3.6);
 translate([-2.4,0,-1])cube([1.2,3.8,5.95],true);
 } 
 if($bearing==0)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=2.6, d1=2.6, d2=0);
  
 if($bearing==1)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=3.2, d1=3.2, d2=0);
 
 if($bearing==2)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=3.5, d=2.2);

 if($bearing==3)rotate([0,90,0])translate([1.5,0,-3.02])cylinder(h=3.5, d=2.7);
 
 //Schmierklappe Abschrägung
 rotate([0,-12.5,0])translate([1.2,-5,-5])cube([10,10,10]);
 
 }
 //Schmierklappe
translate([0,-27,0]) union(){rotate([0,77.0,0])translate([-2.15,13.5,4])minkowski(){cube([4.9,3.5,0.4],true);
    cylinder(h=0.1, d=0.5);
  }
 
rotate([0,77.0,0])translate([-2.51,13.7,4.3])minkowski(){cube([2.0,0.8,0.4],true);
    cylinder(h=0.1, d=0.5);
  }  
 translate([4.0,14.3,2.75])rotate([90,0,0])cylinder(h=1.2, d=0.4);
union(){
translate([3.23,15.5,3.0])rotate([0,77,0])cylinder(h=0.5, d=1.4);

translate([3.56,15.6,3.0])rotate([0,77,0])cylinder(h=0.5, d=0.8, $fn=6);

translate([2.2,15.6,2.61])rotate([0,77,0])scale([0.6,0.6,1])bolt();
}

translate([0,-3.95,0])union(){
translate([3.23,15.5,3.0])rotate([0,77,0])cylinder(h=0.5, d=1.4);

translate([3.56,15.6,3.0])rotate([0,77,0])cylinder(h=0.5, d=0.8, $fn=6);
translate([2.2,15.6,2.61])rotate([0,77,0])scale([0.6,0.6,1.1])bolt();
}
} 
 }
 // Ende Modul Seitenrahmen
 
 // Modul Mittelträger
 module mitte(){
     difference(){
         union(){
   cube([26.75+$width,5.35,8.2],true);
   translate([0,0,1.3+$h])cylinder(h=8, d=5, center=true); 
    cube([9,5,7],true); 
 } 
 translate([0,0,-4.5])cylinder(h=1.0, d1=5.5, d2=3.4);
   cylinder(h=35, d=3, center=true);  
    cube([30.75+$width,4,7],true);
    cube([30.75+$width,7,4],true);
 }
    difference(){cube([7,4,7],true);
     cylinder(h=35, d=3, center=true);   
    }
   translate([9.65+$cor,0,4.08])cube([2,5.35,1.2],true); 
    translate([-9.65-$cor,0,4.08])cube([2,5.35,1.2],true);translate([9.65+$cor,0,-4.08])cube([2,5.35,1.2],true); 
    translate([-9.65-$cor,0,-4.08])cube([2,5.35,1.2],true);  
    
    //Federn
    translate([11.9+$cor,1.0,0])spring();
    translate([11.9+$cor,-1.0,0])spring();   
    translate([-11.9-$cor,1.0,0])spring();
    translate([-11.9-$cor,-1.0,0])spring();   
    
    //Federhalterungen
    translate([12.9+$cor,0,-3.6])scale([1,2,1])cylinder(h=0.3,d=1); 
    translate([12.9+$cor,0,3.3])scale([1,2,1])cylinder(h=0.3,d=1);    
    translate([10.7+$cor,0,-3.6])scale([1,2,1])cylinder(h=0.3,d=1);    
    translate([10.7+$cor,0,3.3])scale([1,2,1])cylinder(h=0.3,d=1);
    translate([-12.9-$cor,0,-3.6])scale([1,2,1])cylinder(h=0.3,d=1); 
    translate([-12.9-$cor,0,3.3])scale([1,2,1])cylinder(h=0.3,d=1);    
    translate([-10.7-$cor,0,-3.6])scale([1,2,1])cylinder(h=0.3,d=1);    
    translate([-10.7-$cor,0,3.3])scale([1,2,1])cylinder(h=0.3,d=1);
    
 }
  // Ende Modul Mitte

// Rendern 
if($render==1)seite();
     
if($render==2)mitte();
 
if($render==3){
    seite();
    translate([-11.4-$cor,0,4.55])mitte();
    translate([-23.15-$width,0,0])rotate([0,0,180]) seite();
} 